package com.elephant.framework.galaxy.aroad.module.zhtj.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import com.elephant.framework.galaxy.aroad.module.zhtj.entity.ZhtjGljbxxGltclc;
import com.elephant.framework.galaxy.aroad.module.zhtj.service.ZhtjGljbxxGltclcService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;

/**
 *  公路通车里程表
 *
 * @author xuzhitu
 * @date 2019-03-11 09:50:32
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhtj/zhtjgljbxxgltclc")
public class ZhtjGljbxxGltclcController extends BaseController  {

  private final ZhtjGljbxxGltclcService zhtjGljbxxGltclcService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhtjGljbxxGltclc  公路通车里程表
   * @return
   */
  @GetMapping("/page")
  public R getZhtjGljbxxGltclcPage(Page page, ZhtjGljbxxGltclc zhtjGljbxxGltclc) {
    if(zhtjGljbxxGltclc.getYear() == null){
      zhtjGljbxxGltclc.setYear("2018");
    }
    return  new R<>(zhtjGljbxxGltclcService.page(page,Wrappers.query(zhtjGljbxxGltclc)));
  }


  /**
   * 通过id查询 公路通车里程表
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") Integer id){
    return new R<>(zhtjGljbxxGltclcService.getById(id));
  }

  /**
   * 新增 公路通车里程表
   * @param zhtjGljbxxGltclc  公路通车里程表
   * @return R
   */
  @SysLog("新增 公路通车里程表")
  @PostMapping
  public R save(@RequestBody ZhtjGljbxxGltclc zhtjGljbxxGltclc){
    return new R<>(zhtjGljbxxGltclcService.save(zhtjGljbxxGltclc));
  }

  /**
   * 修改 公路通车里程表
   * @param zhtjGljbxxGltclc  公路通车里程表
   * @return R
   */
  @SysLog("修改 公路通车里程表")
  @PutMapping
  public R updateById(@RequestBody ZhtjGljbxxGltclc zhtjGljbxxGltclc){
    return new R<>(zhtjGljbxxGltclcService.updateById(zhtjGljbxxGltclc));
  }

  /**
   * 通过id删除 公路通车里程表
   * @param id id
   * @return R
   */
  @SysLog("删除 公路通车里程表")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable Integer id){
    return new R<>(zhtjGljbxxGltclcService.removeById(id));
  }

  /**
   * 公路通车里程Echarts信息
   * @param year 年份
   * @return
   */
  @GetMapping("/chartinfo")
  public R getZhtjGljbxxGltclcChartInfo(@RequestParam String year) {
    return  new R<>(zhtjGljbxxGltclcService.getTclcEchartData(year));
  }

}
